#ifndef NLPKT_H
#define NLPKT_H

#define P2P_NETLINK_TYPE		28
#define P2P_NL_GRP			0
#define P2P_NL_VERSION			1/* scsi_nl_hdr->version value */
#define P2P_MAGIC_NUM_RNQ		144932
#define P2P_NL_K2U			0x01/* kernel -> user */
#define P2P_NL_U2K			0x02/* user -> kernel */
#define P2P_TRANSPORT_MSG		NLMSG_MIN_TYPE + 10 /* Single Netlink Message type to send all P2P Transport messages */

#define P2P_NL_MSGALIGN(len)		(((len) + 7) & ~7)
struct p2p_nl_hdr {
	u8 msgtype;
	u16 msglen;
	u8 version;
	u8 addr1[ETH_ALEN];
	u8 addr2[ETH_ALEN];
	u8 addr3[ETH_ALEN];
}__attribute__((packed));
enum network_mode{
	NETWORK_MODE_WLAN = 0 ,
	NETWORK_MODE_P2P,
};
enum p2p_role {
	P2P_ROLE_NONE = 0,
	P2P_ROLE_DEVICE,
	P2P_ROLE_GO,
	P2P_ROLE_CLIENT,
};
enum drv_event_id {
	DRV_EVENT_RCV_ACTION_FRAME = 0,
	DRV_EVENT_RCV_ASSIGNED_AUTH_REQ,
	DRV_EVENT_RCV_ASSIGNED_BEACON,
	DRV_EVENT_SCAN_RESULTS_AVAILABLE,
	DRV_EVENT_CLIENT_PROV_STATUS,
	DRV_EVENT_CLIENT_ASSOC_STATUS,
	DRV_EVENT_NEW_CLIENT_JOIN,
	DRV_EVENT_DEVICE_FOUND,
	DRV_EVENT_DEVICE_NOT_FOUND,
	DRV_EVENT_GO_DISV_REQ_SENT,
	DRV_EVENT_MY_CLIENT_LEAVE,
	DRV_EVENT_MY_GO_LEAVE,
};
struct drv_event {
	u16 event_id;
	u8 sa[ETH_ALEN];
	u16 data_len;
	u8 data[0];
} __attribute__((packed));
extern int p2p_nl_init(struct net_device *dev);
extern void p2p_nl_exit(void);
extern void p2p_rtllib_softmac_scan_wq(void *data);
extern void p2p_wait_invite_rsp_timer_callback(unsigned long data);
extern void p2p_start_noa(void *data);
extern void p2p_noa_timer_callback(unsigned long data);
extern void p2p_scan(struct rtllib_device *ieee);
extern void p2p_discover(struct rtllib_device *ieee);
extern void p2p_spec_find_phase(struct rtllib_device *ieee);
extern void p2p_only_search(struct rtllib_device *ieee, bool is_go);
extern void p2p_discovery_timer_callback(unsigned long data);
extern void p2p_set_extend_listen_timer_callback(unsigned long data);
extern int p2p_set_leave_idle(struct net_device *dev);
extern int p2p_set_idle(struct net_device *dev);
extern u8 p2p_pending_client_entry_exist(struct rtllib_device *ieee, u8 *addr);
extern void p2p_pending_client_entry_age_timeout(struct rtllib_device *ieee);
extern void p2p_del_pending_client_entry(struct rtllib_device *ieee, u8 idx);
extern void p2p_process_assoc_req(struct rtllib_device *ieee, struct sk_buff *skb);
extern bool p2p_parse_p2p_sub_ie_and_check_noa(u8 *data, u16 data_len, struct rtllib_network *pnetwork);
extern u16 p2p_network_init(struct rtllib_device *ieee,
	struct p2p_network_t *p2p_net,
	struct rtllib_network *network);
extern int p2p_set_leave(struct rtllib_device *ieee, bool is_go);
extern void p2p_deinit_variable(struct rtllib_device *ieee);
#endif
